/*
 * CommGuiView.java
 */

import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.ArrayList;

/**
 * The application's main frame.
 */
public class CommGui extends JFrame {
    
    public CommGui() {
        super("Mote communication GUI");

        try {
	    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {}

        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        initComponents();
        
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();  
        int x = (screenSize.width - getWidth()) / 2;  
        int y = (screenSize.height - getHeight()) / 2;  
        setLocation(x, y);  
        
        infoLabel.setText("Code length: 0");
        msgInfoLabel.setText("Message length: 0");
        sendAgentButton.setEnabled(false);
        sendMsgButton.setEnabled(false);

        recvMsgItemsList = new ArrayList<String>();
        recvMsgList.setListData(recvMsgItemsList.toArray());
    }

    private void initComponents() {

        mainPanel = new JPanel();
        CommTabbedPane = new JTabbedPane();
        SendAgentPanel = new JPanel();
        planBaseLabel = new JLabel("planBase:");
        jScrollPane1 = new JScrollPane();
        planBaseTextArea = new JTextArea();
        planLabel = new JLabel("plan:");
        jScrollPane2 = new JScrollPane();
        planTextArea = new JTextArea();
        beliefBaseLabel = new JLabel("beliefBase:");
        jScrollPane3 = new JScrollPane();
        beliefBaseTextArea = new JTextArea();
        inputBaseLabel = new JLabel("inputBase:");
        jScrollPane4 = new JScrollPane();
        inputBaseTextArea = new JTextArea();
        infoLabel = new JLabel("text");
        addressLabel = new JLabel("Address:");
        addressField = new JTextField();
        sendAgentButton = new JButton("Send agent!");
        SendMsgPanel = new JPanel();
        msgLabel = new JLabel("Message:");
        jScrollPane5 = new JScrollPane();
        msgTextArea = new JTextArea();
        msgInfoLabel = new JLabel("text");
        msgAddressLabel = new JLabel("Address:");
        msgAddressField = new JTextField();
        sendMsgButton = new JButton("Send message!");
        RecvMsgPanel = new JPanel();
        recvMsgLabel = new JLabel("Recieved messages:");
        jScrollPane6 = new JScrollPane();
        recvMsgList = new JList();
        menuBar = new JMenuBar();
        JMenu fileMenu = new JMenu();
        JMenuItem exitMenuItem = new JMenuItem();
        JMenu helpMenu = new JMenu();
        JMenuItem aboutMenuItem = new JMenuItem();

        mainPanel.setMaximumSize(null);

        jScrollPane1.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        jScrollPane2.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        jScrollPane3.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        jScrollPane4.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        jScrollPane1.setMinimumSize(new Dimension(400,40));
        jScrollPane2.setMinimumSize(new Dimension(400,40));
        jScrollPane3.setMinimumSize(new Dimension(400,40));
        jScrollPane4.setMinimumSize(new Dimension(400,40));

        planBaseTextArea.setColumns(50);
        planBaseTextArea.setLineWrap(true);
        planBaseTextArea.setRows(4);
        planBaseTextArea.addCaretListener(new CaretListener() {
            public void caretUpdate(CaretEvent evt) {
                zmenInfoText(evt);
            }
        });
        jScrollPane1.setViewportView(planBaseTextArea);

        planTextArea.setColumns(50);
        planTextArea.setLineWrap(true);
        planTextArea.setRows(3);
        planTextArea.addCaretListener(new CaretListener() {
            public void caretUpdate(CaretEvent evt) {
                zmenInfoText(evt);
            }
        });
        jScrollPane2.setViewportView(planTextArea);
        beliefBaseTextArea.setColumns(50);
        beliefBaseTextArea.setLineWrap(true);
        beliefBaseTextArea.setRows(2);
        beliefBaseTextArea.addCaretListener(new CaretListener() {
            public void caretUpdate(CaretEvent evt) {
                zmenInfoText(evt);
            }
        });
        jScrollPane3.setViewportView(beliefBaseTextArea);

        inputBaseTextArea.setColumns(50);
        inputBaseTextArea.setLineWrap(true);
        inputBaseTextArea.setRows(2);
        inputBaseTextArea.addCaretListener(new CaretListener() {
            public void caretUpdate(CaretEvent evt) {
                zmenInfoText(evt);
            }
        });
        jScrollPane4.setViewportView(inputBaseTextArea);

        infoLabel.setHorizontalAlignment(SwingConstants.CENTER);
        
        addressField.setColumns(4);

        sendAgentButton.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent evt) {
                sendAgent(evt);
            }
        });

        
        GroupLayout SendAgentPanelLayout = new GroupLayout(SendAgentPanel);
        SendAgentPanel.setLayout(SendAgentPanelLayout);
        SendAgentPanelLayout.setHorizontalGroup(
            SendAgentPanelLayout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(SendAgentPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(SendAgentPanelLayout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, GroupLayout.DEFAULT_SIZE, 297, Short.MAX_VALUE)
                    .addComponent(planBaseLabel)
                    .addComponent(planLabel)
                    .addComponent(jScrollPane1, GroupLayout.DEFAULT_SIZE, 297, Short.MAX_VALUE)
                    .addComponent(beliefBaseLabel)
                    .addComponent(jScrollPane3, GroupLayout.DEFAULT_SIZE, 297, Short.MAX_VALUE)
                    .addComponent(inputBaseLabel)
                    .addComponent(jScrollPane4, GroupLayout.DEFAULT_SIZE, 297, Short.MAX_VALUE)
                    .addComponent(infoLabel, GroupLayout.DEFAULT_SIZE, 297, Short.MAX_VALUE)
                    .addGroup(SendAgentPanelLayout.createSequentialGroup()
                        .addComponent(addressLabel)
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(addressField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED, 103, Short.MAX_VALUE)
                        .addComponent(sendAgentButton)))
                .addContainerGap())
        );
        SendAgentPanelLayout.setVerticalGroup(
            SendAgentPanelLayout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(SendAgentPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(planBaseLabel)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(planLabel)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(beliefBaseLabel)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane3, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(inputBaseLabel)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane4, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(infoLabel)
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(SendAgentPanelLayout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(addressLabel)
                    .addComponent(addressField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(sendAgentButton))
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED))
        );

        CommTabbedPane.addTab("Agent sending", SendAgentPanel); // NOI18N

        //CommTabbedPane.setMinimumSize(new Dimension(400,10));
        
        jScrollPane5.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        
        msgTextArea.setColumns(50);
        msgTextArea.setLineWrap(true);
        msgTextArea.setRows(3);
        msgTextArea.addCaretListener(new CaretListener() {
            public void caretUpdate(CaretEvent evt) {
                zmenMsgInfoText(evt);
            }
        });
        jScrollPane5.setViewportView(msgTextArea);

        msgInfoLabel.setHorizontalAlignment(SwingConstants.CENTER);

        msgAddressField.setColumns(4);

        sendMsgButton.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent evt) {
                sendMsg(evt);
            }
        });

        GroupLayout SendMsgPanelLayout = new GroupLayout(SendMsgPanel);
        SendMsgPanel.setLayout(SendMsgPanelLayout);
        SendMsgPanelLayout.setHorizontalGroup(
            SendMsgPanelLayout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(SendMsgPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(SendMsgPanelLayout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane5, GroupLayout.DEFAULT_SIZE, 297, Short.MAX_VALUE)
                    .addComponent(msgLabel)
                    .addComponent(msgInfoLabel, GroupLayout.DEFAULT_SIZE, 297, Short.MAX_VALUE)
                    .addGroup(SendMsgPanelLayout.createSequentialGroup()
                        .addComponent(msgAddressLabel)
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(msgAddressField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED, 105, Short.MAX_VALUE)
                        .addComponent(sendMsgButton)))
                .addContainerGap())
        );
        SendMsgPanelLayout.setVerticalGroup(
            SendMsgPanelLayout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(SendMsgPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(msgLabel)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane5, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED, 180, 247)
                .addComponent(msgInfoLabel)
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(SendMsgPanelLayout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(msgAddressLabel)
                    .addComponent(msgAddressField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addComponent(sendMsgButton))
                .addContainerGap())
        );

        CommTabbedPane.addTab("Message sending", SendMsgPanel); // NOI18N

        jScrollPane6.setViewportView(recvMsgList);

        GroupLayout RecvMsgPanelLayout = new GroupLayout(RecvMsgPanel);
        RecvMsgPanel.setLayout(RecvMsgPanelLayout);
        RecvMsgPanelLayout.setHorizontalGroup(
            RecvMsgPanelLayout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(RecvMsgPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(RecvMsgPanelLayout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane6, GroupLayout.DEFAULT_SIZE, 297, Short.MAX_VALUE)
                    .addComponent(recvMsgLabel))
                .addContainerGap())
        );
        RecvMsgPanelLayout.setVerticalGroup(
            RecvMsgPanelLayout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(RecvMsgPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(recvMsgLabel)
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane6, GroupLayout.PREFERRED_SIZE, 360, GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        CommTabbedPane.addTab("Recieved messages", RecvMsgPanel); // NOI18N

        CommTabbedPane.setSelectedComponent(SendAgentPanel);

        GroupLayout mainPanelLayout = new GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addComponent(CommTabbedPane, GroupLayout.DEFAULT_SIZE, 322, Short.MAX_VALUE)
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addComponent(CommTabbedPane, GroupLayout.DEFAULT_SIZE, 446, Short.MAX_VALUE)
        );

        fileMenu.setText("File");

        Action quit = new AbstractAction() {
            public void actionPerformed(ActionEvent e) {
                System.exit(1);
            }
        };

        Action showAboutBox = new AbstractAction() {
            public void actionPerformed(ActionEvent e) {
                zobrazAbout();
            }
        };

        ActionMap actionMap = new ActionMap();
        actionMap.put("quit", quit);
        actionMap.put("showAboutBox", showAboutBox);
        KeyStroke ctrlQ = KeyStroke.getKeyStroke(KeyEvent.VK_Q,InputEvent.CTRL_MASK);

        exitMenuItem.setAction(actionMap.get("quit")); // NOI18N
        exitMenuItem.setText("Quit"); // NOI18N
        exitMenuItem.setAccelerator(ctrlQ);
        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        helpMenu.setText("Help"); // NOI18N

        aboutMenuItem.setAction(actionMap.get("showAboutBox")); // NOI18N
        aboutMenuItem.setText("About..."); // NOI18N
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        setContentPane(mainPanel);
        setJMenuBar(menuBar);
        setResizable(false);
        pack();
    }

    private void zobrazAbout() {
        if (aboutBox == null) {
            aboutBox = new CommGuiAboutBox(this);
            aboutBox.setLocationRelativeTo(this);
        }
        aboutBox.setVisible(true);
    }

    private void zmenInfoText(CaretEvent evt) {
        int delka = 0;

        delka += planBaseTextArea.getText().length();
        delka += planTextArea.getText().length();
        delka += beliefBaseTextArea.getText().length();
        delka += inputBaseTextArea.getText().length();

        infoLabel.setText("Code length: " + Integer.toString(delka));

        if (delka > 2080 || delka < 1) {
            sendAgentButton.setEnabled(false);
        } else {
            sendAgentButton.setEnabled(true);
        }
    }

    private void sendAgent(MouseEvent evt) {
        String kod;
        int pb, plan, bb, ib, reg1, reg2, reg3;
        int adresa;

        if (addressField.getText().length() == 0 || !addressField.getText().equals(Integer.toString(adresa = Integer.parseInt(addressField.getText()))) || adresa < 1) {
            JOptionPane.showMessageDialog(mainPanel,"You have entered wrong mote address!","Error",JOptionPane.ERROR_MESSAGE);
            return;
        }

        kod = "";

        pb = 0;
        kod += planBaseTextArea.getText();

        plan = kod.length();
        kod += planTextArea.getText();

        bb = kod.length();
        kod += beliefBaseTextArea.getText();

        ib = kod.length();
        kod += inputBaseTextArea.getText();

        reg1 = reg2 = reg3 = kod.length();

        kod = kod.replaceAll("\n", "").replaceAll("\t", "").replaceAll(" ", ""); // odstraneni whitespace znaku
                
        kod += '\0';
        // pripraveny indexy a pole z celym retezcem

        //System.out.println("adresa: " + Integer.toString(adresa) + " - kod: " + kod + " - delka: " + Integer.toString(kod.length()));

        comm.sendAgent(adresa, kod, pb, plan, bb, ib, reg1, reg2, reg3);
        
        sendMsgButton.setEnabled(false);
        sendAgentButton.setEnabled(false);
        infoLabel.setText("Sending in progress...");
    }

    private void sendMsg(MouseEvent evt) {
        String zprava;
        int adresa;

        if (msgAddressField.getText().length() == 0 || !msgAddressField.getText().equals(Integer.toString(adresa = Integer.parseInt(msgAddressField.getText()))) || adresa < 1) {
            JOptionPane.showMessageDialog(mainPanel,"You have entered wrong mote address!","Error",JOptionPane.ERROR_MESSAGE);
            return;
        }

        zprava = msgTextArea.getText();

        // pripraveny indexy a pole z celym retezcem

        //System.out.println("adresa: " + Integer.toString(adresa) + " - zprava: " + zprava + " - delka: " + Integer.toString(zprava.length()));

        comm.sendMsg(adresa, zprava);
        
        sendMsgButton.setEnabled(false);
        sendAgentButton.setEnabled(false);
        infoLabel.setText("Sending in progress...");
    }

    private void zmenMsgInfoText(CaretEvent evt) {
        int delka = msgTextArea.getText().length();

        msgInfoLabel.setText("Message length: " + Integer.toString(delka));

        if (delka > 200 || delka < 1) {
            sendMsgButton.setEnabled(false);
        } else {
            sendMsgButton.setEnabled(true);
        }
    }

    public void addMsg(String msg, int addr) {
        recvMsgItemsList.add(new String("Addr: " + Integer.toString(addr) + " - msg: '" + msg + "'"));

        recvMsgList.setListData(recvMsgItemsList.toArray());
    }

    public void enableSendButtons() {
        sendAgentButton.setEnabled(true);
        sendMsgButton.setEnabled(true);
    }
    
    public void connect(String addr) {
        comm = new Comm(this, addr);
    }
    
    public JLabel getInfoLabel() {
        return infoLabel;
    }
    
    public JLabel getMsgInfoLabel() {
        return msgInfoLabel;
    }
    
    private JTabbedPane CommTabbedPane;
    private JPanel RecvMsgPanel;
    private JPanel SendAgentPanel;
    private JPanel SendMsgPanel;
    private JTextField addressField;
    private JLabel addressLabel;
    private JLabel beliefBaseLabel;
    private JTextArea beliefBaseTextArea;
    private JLabel infoLabel;
    private JLabel inputBaseLabel;
    private JTextArea inputBaseTextArea;
    private JScrollPane jScrollPane1;
    private JScrollPane jScrollPane2;
    private JScrollPane jScrollPane3;
    private JScrollPane jScrollPane4;
    private JScrollPane jScrollPane5;
    private JScrollPane jScrollPane6;
    private JPanel mainPanel;
    private JMenuBar menuBar;
    private JTextField msgAddressField;
    private JLabel msgAddressLabel;
    private JLabel msgInfoLabel;
    private JLabel msgLabel;
    private JTextArea msgTextArea;
    private JLabel planBaseLabel;
    private JTextArea planBaseTextArea;
    private JLabel planLabel;
    private JTextArea planTextArea;
    private JLabel recvMsgLabel;
    private JList recvMsgList;
    private JButton sendAgentButton;
    private JButton sendMsgButton;
  
    private JDialog aboutBox;
    private ArrayList<String> recvMsgItemsList;
    private Comm comm;

    public static void main(String[] args) {
        ConnDialog dialog = new ConnDialog(new CommGui());
        dialog.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
            System.exit(0);
            }
        });
        dialog.setVisible(true);
    }
}


