/*
 * ConnDialog.java
 *
 * Created on 24.4.2009, 20:35:46
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class ConnDialog extends JDialog {

    private CommGui commGui;
    
    public ConnDialog(CommGui cg) {
        super((Frame)null, "Enter port", true);

        commGui = cg;
        
        try {
	    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {}
        
        initComponents();
        
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();  
        int x = (screenSize.width - getWidth()) / 2;  
        int y = (screenSize.height - getHeight()) / 2;  
        setLocation(x, y);  
    }

    private void initComponents() {

        connLabel = new JLabel();
        connField = new JTextField();
        cancelButton = new JButton();
        okButton = new JButton();

        setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);

        connLabel.setText("Enter port:"); // NOI18N
        connField.setText("serial@/dev/ttyUSB1:micaz"); // NOI18N
        
        cancelButton.setText("Cancel"); // NOI18N
        cancelButton.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent evt) {
                System.exit(0);
            }
        });

        okButton.setText("Connect"); // NOI18N
        okButton.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent evt) {
                buttonPressed(evt);
            }
        });

        GroupLayout layout = new GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(connLabel)
                    .addGroup(layout.createParallelGroup(GroupLayout.Alignment.TRAILING, false)
                        .addGroup(GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                            .addComponent(cancelButton)
                            .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(okButton))
                        .addComponent(connField, GroupLayout.Alignment.LEADING, GroupLayout.PREFERRED_SIZE, 189, GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(connLabel)
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(connField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(cancelButton)
                    .addComponent(okButton))
                .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }


    private void buttonPressed(MouseEvent evt) {
        setVisible(false);
        commGui.setVisible(true);
        commGui.connect(connField.getText());
    }

    private JButton cancelButton;
    private JTextField connField;
    private JLabel connLabel;
    private JButton okButton;

}
