/**
 * Hlavickovy soubor definuje konstanty a datove typy pouzivane Platformou.
 *
 * @author Jan Horacek, xhorac08
 **/
#ifndef AM_AGENT_H
#define AM_AGENT_H
#include "Send.h"

//paket bude pro flexibilizu pole bytu, mame 28 bytu pro jeden paket
typedef nx_struct send_msg {
  nx_uint8_t msg[28];
} send_msg_t;

//celkem mame 3 typy zprav, agent, normalni zprava a potvrzovani paketu
enum {
  AM_AGENT_MSG = 6,
  AM_NORMAL_MSG = 7,
  AM_ACK_MSG = 8,
  AM_NEIGBOUR_MSG = 9,
};

enum {
  NEIGHBOUR_DISC = 0,
  NEIGHBOUR_ECHO = 1,
};

//pro rozliseni co v danou chvili zasilame v modulu SendM (typ akce)
enum {
  AGENT_MSG = 0,
  NORMAL_MSG = 1,
};

//ruzne typy odpovedi pri potvrzovani
enum {
  ACK_OK = 1, //zprava je v poradku
  ACK_RESEND = 2, //zasli cele znovu
  ACK_HAVE_IT = 3, //uz danou zpravu mam
};

//sdileny buffer pro zasilani zprav, interpret si to dovnitr posklada a pak zavola akci
#ifdef TOSSIM
char input_message[MAX_MSG_LEN+1];
#else
char input_message[MAX_MSG_LEN];
#endif

// enum {
//   SEND_AGENT_START = 128,
//   SEND_AGENT_CONT = 129,
//   SEND_AGENT_ACK = 130,
//   SEND_AGENT_STOP = 131,
//   NOTE_ERROR = 255,
// };

//sdilene flagy
bool running_code = FALSE; //jsme ve smycce?
bool recieving_code = FALSE; //prijimame agentni kod?

//pri posilani agenta potrebuje docasne ukazatele na registry
uint16_t temp_PlanIndex;
uint16_t temp_PlanBaseIndex;
uint16_t temp_BeliefBaseIndex;
uint16_t temp_InputBaseIndex;
uint16_t temp_Reg1Index;
uint16_t temp_Reg2Index;
uint16_t temp_Reg3Index;

//konstanty pro modul SensorsM (co za akci bylo zvoleno)
enum {
  SEN_TIMER = 1, //bezny stav - intervalove snimani
  SEN_ACTUAL = 2, //chceme aktualni hodnotu
  SEN_MAX = 3, //chceme maximalni hodnotu od zvoleneho obdobi
  SEN_MIN = 4,
  SEN_AVG = 5,
};

typedef struct nb_disc {
  uint16_t nodeID;
  uint8_t strength;
} nb_disc_t;

enum {
  NB_DISC_BUFF_SIZE = 16, //velikost bufferu pro prozkoumani okoli
};

uint16_t ag_class = 0;
uint16_t ag_id = 0;

#define MIN(a, b)  (((a) < (b)) ? (a) : (b))
#define MAX(a, b)  (((a) > (b)) ? (a) : (b))

#endif
